#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Array.au3>
#include <Math.au3>
#include <Misc.au3>
#include <Sound.au3>


Const $bpm=240 ;schne Speed (bei 240 ein Takt pro Sekunde)
Const $takte=60*5

$wait=500/($bpm/60) ;bei 120 beats per minute sind 2/4 noten eine Sekunde
Dim $toene[1] ;[0]=Anzahl, [1...]="1C#8": <Tonanzahl>[<Ton><Vorzeichen><Tongre 1/x>]...    Cb4
$toene[0]=0                        ;1/8 ist das krztmgliche, langsamstes: 1/1
Dim $sounds[12]

Init()
$durmoll=Generate($toene,$takte)

Do
	TrayTip("",$durmoll,10)
	$warten=0
	For $x=1 To $toene[0]
		$warten=0
		$tonzahl=StringLeft($toene[$x],1)
		For $i=0 To $tonzahl-1
			$warten=_Max(Number(Play(StringMid($toene[$x],2+$i*3,3))),$warten)
		Next
		$warten=$wait/($warten/8)
		Sleep($warten)
	Next
Until MsgBox(4,"Wiederholung","Nocheinmal abspielen?")<>6

Uninit()
Exit






Func Play($ton) ;C 4
	Local $plnum=-1
	Switch (StringLeft($ton,2))
		Case "C "
			$plnum=0
		Case "C#"
			$plnum=1
		Case "D "
			$plnum=2
		Case "D#"
			$plnum=3
		Case "E "
			$plnum=4
		Case "F "
			$plnum=5
		Case "F#"
			$plnum=6
		Case "G "
			$plnum=7
		Case "G#"
			$plnum=8
		Case "A "
			$plnum=9
		Case "A#"
			$plnum=10
		Case "H "
			$plnum=11
	EndSwitch
	_SoundPlay($sounds[$plnum])
	Return StringRight($ton,1)
EndFunc

Func Init()
	Local $endung="wav"
	$sounds[0]=_SoundOpen(@ScriptDir&"\SFX\C ."&$endung)
	$sounds[1]=_SoundOpen(@ScriptDir&"\SFX\C#."&$endung)
	$sounds[2]=_SoundOpen(@ScriptDir&"\SFX\D ."&$endung)
	$sounds[3]=_SoundOpen(@ScriptDir&"\SFX\D#."&$endung)
	$sounds[4]=_SoundOpen(@ScriptDir&"\SFX\E ."&$endung)
	$sounds[5]=_SoundOpen(@ScriptDir&"\SFX\F ."&$endung)
	$sounds[6]=_SoundOpen(@ScriptDir&"\SFX\F#."&$endung)
	$sounds[7]=_SoundOpen(@ScriptDir&"\SFX\G ."&$endung)
	$sounds[8]=_SoundOpen(@ScriptDir&"\SFX\G#."&$endung)
	$sounds[9]=_SoundOpen(@ScriptDir&"\SFX\A ."&$endung)
	$sounds[10]=_SoundOpen(@ScriptDir&"\SFX\A#."&$endung)
	$sounds[11]=_SoundOpen(@ScriptDir&"\SFX\H ."&$endung)
EndFunc

Func Uninit()
	For $x=0 To 11
		_SoundClose($sounds[$x])
	Next
EndFunc

Func Generate(ByRef $toene,$takte)
	Local $durmoll=Random(0,1,1)
	Local $tones="1C 1"
	Local $lastakk="C E G ",$lltone,$lldiff=0
	For $x=1 To $takte
		Local $t=0
		While $t<>1
			Local $toze=0
			While $toze=0 Or $t+1/$toze>1
				$toze=2^_Iif(Random(0,10,1)=0,2,3)
			WEnd
			$t+=1/$toze
			$lltone=$tones
			If ($x=1 And $t=1/$toze) Or ($x=$takte And $t=1) Then
				$tones="C "&$toze
			Else
				Local $last=ToneToNumber(StringTrimLeft($tones,1)),$next,$akkt
				Do
					$akkt=StringMid($lastakk,1+Random(0,2,1)*2,2)
					$next=ToneToNumber($akkt)
				Until $lldiff+Abs($next-$last)>0
				$tones=$akkt&$toze
			EndIf
			$lldiff=Abs(ToneToNumber(StringTrimLeft($lltone,1))-ToneToNumber($tones))
			If $t-1/$toze=0 Then
				Local $akk[3]
				Select
					Case $x=1
						$akk[0]="C "
					Case $x=2
						$akk[0]="F "
					Case $x=3
						$akk[0]="G "
					Case Else
						$akk[0]=NumberToTone(Random(1,7,1))&" "
				EndSelect
				$akk[1]=AddHalftone($akk[0],_Iif($durmoll,3,4))
				$akk[2]=AddHalftone($akk[1],_Iif($durmoll,4,3))
				$lastakk=$akk[0]&$akk[1]&$akk[2]
				$tones="1"&$tones
			Else
				$tones="1"&$tones
			EndIf
			_ArrayAdd($toene,$tones)
			$toene[0]+=1
		WEnd
	Next
	Return _Iif($durmoll,"Moll","Dur")
EndFunc



Func AddHalftone($note,$sprung)
	Local $i
	For $i=1 To $sprung
		If StringRight($note,1)="#" Then
			$note=NumberToTone(ToneToNumber($note)+1)&" "
		Else
			If StringLeft($note,1)="E" Then
				$note="F "
			ElseIf StringLeft($note,1)="H" Then
				$note="C "
			Else
				$note=StringLeft($note,1)&"#"
			EndIf
		EndIf
	Next
	Return $note
EndFunc

Func ToneToNumber($ton)
	Local $notenreihe="CDEFGAH",$x
	For $x=1 To 7
		If StringMid($notenreihe,$x,1)=StringLeft($ton,1) Then Return $x
	Next
EndFunc

Func NumberToTone($number)
	$number=Mod($number+7,7)
	If $number=0 Then $number=7
	Local $notenreihe="CDEFGAH"
	Return StringMid($notenreihe,$number,1)
EndFunc

